{*******************************************************************************
   Ttulo: ICalculoImposto
Descrio: Classe que contem as definies para as classes concretas que
           implementaro os algoritmos para calculo dos impostos.
           Exerce o papel da Strategy dentro do Padro Strategy.
    Autor: David Pagliotto
  Contato: david_pagliotto@hotmail.com
*******************************************************************************}

unit ICalculoImposto;

interface

uses
  Forms, Windows;

type
  TICalculoImposto = class
  published
    procedure CalcularImposto(); virtual;
end;

implementation

procedure TICalculoImposto.CalcularImposto();
var
  ConcreteStrategy: String;
begin
  ConcreteStrategy := Self.ClassName;
  Application.MessageBox(PWideChar('O mtodo CalcularImposto() no foi reescrito na classe ' + ConcreteStrategy + '.'),
                         '..:: Ateno ::..', MB_ICONWARNING + MB_OK);
end;

end.

